/* 
Program: sList-v2.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function:
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

/* 禡쫬ŧi */
void insert();
void del();
void modify();
void display();
void processing();
void readFileData();
void saveFileData();

/* ŧi@ӵcҪ */
typedef struct Node node; /* `Ntypedefŧi覡A̧ǧ@pUŧiAѨ https://bit.ly/3DKzqoZ */ 
struct Node {
    long int id;
    char name[10];
    double score;
    node *next;
};

node *head, *pNode, *current, *prev, temp, *tail; /* cܼ */

FILE *fptr;

int main()
{
    tail = head = (node *)malloc(sizeof(node));
    head->next = NULL;
    
    readFileData();
    
    /* QΤ@ϥοܥ\ඵ */
    char choice; //int choice;
    do {
        printf("\n" \
			   "    \\   \n" \
			   "\n" \
			   " 1. [J`I \n" \
			   " 2. R`I \n" \
			   " 3. ק`I \n" \
			   " 4. ܩҦ \n" \
			   " 5.      \n" \
			   "\n" \
			   "п => ");
        choice = getche(); //scanf("%d", &choice);
        switch (choice) {
            case '1':
                insert(1,NULL,0);
                break;
            case '2':
                del();
                break;
            case '3':
                modify();
                break;
            case '4':
                display();
                break;
            case '5':
                printf("\n\n{ABye!\n");
                break; //exit(0);
            default:
                printf("JﶵƦrTAЭ@\n");
        }
        printf("\n");
    } while (choice != '5');
    //getchar();
    saveFileData();
    
    return 0;
}

/* ӤƥѤjܤp[J@`I쵲C */
void insert(int mode, node *pNode)  
{
	if (mode == 1) {
    	pNode = malloc(sizeof(node)); /* Qmalloc()tmO鵹pNode */
    	printf("\nпJID: ");
    	scanf("%ld",&pNode->id);
    	printf("пJmW: ");
    	scanf("%s",pNode->name);
    	printf("пJ: ");
   		scanf("%lf",&pNode->score);
	}
    
    /* [J@`I쵲C */
    current = head->next;
    prev = head;
    /* P_쵲CO_ */
    if (current == NULL) {
        head->next = pNode;
        pNode->next = NULL;
    }
    else { /* YOŪAhAm[J쵲C */
        while ((current != NULL) && (pNode->score < current->score)) {
            prev = current;
            current = current->next;
        }
        prev->next = pNode;
        pNode->next = current;
   	}
}

/* RY@`I*/
void del()
{
    long int deleteID;
    
    current = head->next; /* N current ЫV head U@Ӹ`I */
    prev = head;
    /* P_쵲CO_ */
    if (current != NULL) { /* YOŪAhMR`I */ 
        printf("\nпJR ID: ");
        scanf("%ld", &deleteID);
        while ((current != NULL) && (current->id != deleteID)) { /* MR`I */ 
            prev = current;
            current = current->next;
        }
        if (current != NULL) { /* YAhNR */ 
            prev->next = current->next;
            //current->next = NULL;
			printf("ID: %ld wR\n",current->id);
			free(current);
        }
        else { /* YSAhX䤣R`IT*/ 
            printf("\n䤣R`I\n");
        }
    }
    else { /* YOŪAhX쵲COŪT */
        printf("쵲COŪ\n");
    }
}

/* קY@`I */
void modify()
{
    node *temp;
    long int modifyID;
    double modifyScore;
    int flag = 0;
    
	printf("\nпJק`I ID: ");
    scanf("%ld",&modifyID);
    current = head->next;
    prev = head;
    
    while (current != NULL) { /* Mק諸`I */
        if (current->id == modifyID) {
            printf("ثeק`IƦpU:\n");
            printf("%6ld %10s %8.1f\n\n",current->id,current->name,current->score);
            printf("пJק諸: ");
            scanf("%lf",&modifyScore);
            current->score = modifyScore;
            flag = 1;
            break;
        }
        else {
            prev = current;
            current = current->next;
        }
    }
    
    if (flag != 0) { /* ק諸`I */
        /* Ncurrent`Iwtemp */
        temp = current;
        prev->next = current->next;
        /* temp`I[J쵲C */
        current = head->next;
        prev = head;
        while ((current != NULL) && (temp->score < current->score)) {
            prev = current;
            current = current->next;
        }
        prev->next = temp;
        temp->next = current;
    }
    else {
        printf("䤣ק諸`I\n");
    }
}

void display() /* 쵲CҦ`I */
{
	int count = 0;
	
	current = head->next; /* NcurrentЫVheadU@Ӹ`I */
      
    /* ˵쵲CO_ */
    if (current != NULL) {
        printf("\n\n   ID  Name          Score\n------+----------+----------\n");
        while (current != NULL) {
            printf("%6ld %-10s %8.1f\n",current->id,current->name,current->score);
            current = current->next; /* NвU@Ӹ`I */
            count++;
        }
        printf("------+----------+----------\n@%d\n\nN~...",count);
        getch();
        system("cls");
    }
    else { /* YOŪAhX쵲CL */
        printf("\n쵲CL\n");
    }
}

void readFileData()
{
	node temp, *ptr, *current;
	
	if ((fptr=fopen("studentScores.txt","r+")) == NULL) {
		printf("\nJrɮפsb");
		return;
	}
	
	while (fscanf(fptr,"%ld %s %lf",&temp.id,temp.name,&temp.score) != EOF) { /* ŪgY|FEOF(end of file)аOB */
		tail = tail->next = ptr = (node *)malloc(sizeof(node));
		*ptr = temp; /* temp`IeƻsptrЩҫVŶ */
		ptr->next = NULL;
	}
	
	printf("wŪstudentScores.txtɮסAlƦpU...");
	display();	/* qثeCe(|HưCƦC) */ 
	for (current=head->next, head->next = NULL; current; current = ptr) {
		ptr = current->next; /* OptrOU@Ӹ`I} */ 
		insert(0,current);
	}
	printf("̤ưCƦCsCƦpU...");
	display();	/* qثeCe(wHưCƦC) */
}

void saveFileData()
{
	rewind(fptr); /* ɮŪgY˦^̶}lm */ 
	
	current = head->next; /* currentЫVheadU@Ӹ`I */
    while (current != NULL) {
        fprintf(fptr,"%6ld %-10s %8.1f\n",current->id,current->name,current->score);
        current = current->next;  
    }
	
	fclose(fptr);
}
