/* 
Program: sList-v3a.c (Report comments/bugs to chikh@yuntech.edu.tw)
Function: XRsList-v2.c{A{GӦCOOZѰܧCƦCIDѤpj
	C覡AHɥiHؤ覡e{Ce
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>

#define inputFile "studentScores.txt"

/* 禡쫬ŧi */
void insert();
void del();
void modify();
void display();
void processing();
void readFileData(char *);
void reorder();	/* sƦC */ 

/* ŧi@ӵcҪ */
typedef struct Node node; 
struct Node {
    long int id;
    char name[10];
    double score;
    node *next;
};

typedef struct data index;	/* ۭquޡvƫAANOǥ͸Ƹ`I}T */ 
struct data {	/* JƭlANΦt@C */			
	node  *nd;	/* ǥͦZ`I} */ 
	index *next;
};

node *head, *pNode, *current, *prev, temp, kopf, *tail = &kopf; /* cܼ */
index listPtrHead, *ptrTail = &listPtrHead;

int main()
{
    head = (node *)malloc(sizeof(node));
    head->next = NULL;
    
    readFileData(inputFile);
    printf("\n*** Cmߵ{ ***\n\nwq%sŪƨêlƦC (N}l޲z...)",inputFile);
    getche();
    
    char choice; 
    do {
    	system("cls");	/* Mù */ 
    	/* ܿϥοܥ\ඵ */
        printf("\n" \
			   "    \\    \n" \
			   "\n" \
			   " 1. [J`I  \n" \
			   " 2. R`I  \n" \
			   " 3. ק`I  \n" \
			   " 4. ܩҦ  \n" \
			   " 5. sƧ  \n" \
			   " 6.       \n" \
			   "\n" \
			   "п => ");
        choice = getche(); 
        switch (choice) {
            case '1':
                insert(1,NULL,0);
                break;
            case '2':
                del();
                break;
            case '3':
                modify();
                break;
            case '4':
                display(head->next);
                break;
            case '5':
            	reorder();
            	break;
			case '6':
                printf("\n{\n");
                exit(0);
            default:
                printf("JﶵƦrTAЭ@\n");            
        }
        printf("\n");
    } while (choice != '6');

    return 0;
}

/* ӤƥѤjܤp[J@`I쵲C */
void insert(int mode, node *pNode, int indexByID)
{
	if (mode == 1) {
    	pNode = (node *)malloc(sizeof(node)); /* Qmalloc()禡tmO鵹pNode */
    	printf("\nпJID: ");
    	scanf("%ld",&pNode->id);
    	printf("пJmW: ");
    	scanf("%s",pNode->name);
    	printf("пJ: ");
   		scanf("%lf",&pNode->score);
   		ptrTail = ptrTail->next = (index *)malloc(sizeof(index));
		ptrTail->nd = pNode;
		ptrTail->next = NULL;
	}
    
    /* [J@`I쵲C */
    current = head->next;
    prev = head;
    /* P_쵲CO_ */
    if (current == NULL) {
        head->next = pNode;
        pNode->next = NULL;
    }
    else { /* YOŪAhAm[J쵲C */
    	if (indexByID)
    		while ((current != NULL) && (pNode->id > current->id)) {
            	prev = current;
            	current = current->next;
        	}
    	else
        	while ((current != NULL) && (pNode->score < current->score)) {
            	prev = current;
            	current = current->next;
        	}
        prev->next = pNode;
        pNode->next = current;
   	}
}

/* RY@`I*/
void del()
{
    long int deleteID;
    index *frueher, *p;
    
    current = head->next; /* currentЫVheadU@Ӹ`I */
    prev = head;
    /* P_쵲CO_ */
    if (current != NULL) { /* YOŪAhMR`I */ 
        printf("\nпJR ID: ");
        scanf("%ld", &deleteID);
        while ((current != NULL) && (current->id != deleteID)) { /* MR`I */ 
            prev = current;
            current = current->next;
        }
        if (current != NULL) { /* YAhNR */ 
            prev->next = current->next;
            //current->next = NULL;
            /* վlC */
            for (frueher = &listPtrHead, p = listPtrHead.next; p; p = p->next) {
            	if (p->nd == current) break;
            	frueher = p;
			}
			frueher->next = p->next;
			if (ptrTail->nd == current) ptrTail = frueher;
			/* վlC */
			printf("ID: %ld wR\n", current->id);
			free(current);
        }
        else { /* YSAhX䤣R`IT*/ 
            printf("\n䤣R`I\n");
        }
    }
    else { /* YOŪAhX쵲COŪT */
        printf("쵲COŪ\n");
    }
}

/* קY@`I */
void modify()
{
    node *temp;
    long int modifyID;
    double modifyScore;
    int flag = 0;
    
	printf("\nпJק`I ID: ");
    scanf("%ld", &modifyID);
    current = head->next;
    prev = head;
    
    while (current != NULL) { /* Mק諸`I */
        if (current->id == modifyID) {
            printf("ثeק`IƦpU:\n");
            printf("%6ld %10s %8.1f\n\n", current->id,current->name,current->score);
            printf("пJק諸: ");
            scanf("%lf", &modifyScore);
            current->score = modifyScore;
            flag = 1;
            break;
        }
        else {
            prev = current;
            current = current->next;
        }
    }
    
    if (flag != 0) { /* ק諸`I */
        /* Ncurrent`Iwtemp */
        temp = current;
        prev->next = current->next;
        /* temp`I[J쵲C */
        current = head->next;
        prev = head;
        while ((current != NULL) && (temp->score < current->score)) {
            prev = current;
            current = current->next;
        }
        prev->next = temp;
        temp->next = current;
    }
    else {
        printf("䤣ק諸`I\n");
    }
}


void display(node *current) /* 쵲CҦ`I */
{
    //current = head->next; /* currentЫVheadU@Ӹ`I */
    
    /* ˵쵲CO_ */
    if (current != NULL) {
        printf("\n%6s %6s %12s\n", "ID", "Name", "Score");
        while (current != NULL) {
            printf("%6ld %-10s %7.1f\n",current->id,current->name,current->score);
            current = current->next; /* NвU@Ӹ`I */
        }
    }
    else  /* YOŪAhX쵲CL */
        printf("\n쵲CL\n");
    
    system("pause");
}

void readFileData(char *fileName)
{
	FILE *fptr;
	node temp, *ptr;
	index *p; 
	
	if ((fptr=fopen(fileName,"r")) == NULL) {
		printf("\nJrɮפsb");
		return;
	}
	
	while (fscanf(fptr,"%ld %s %lf",&temp.id,temp.name,&temp.score) != EOF) { /* ŪgY|FEOF(end of file)аOB */
		tail = tail->next = ptr = (node *)malloc(sizeof(node));
		*ptr = temp; /* temp`IeƻsptrЩҫVŶ */
		ptr->next = NULL;
		ptrTail = ptrTail->next = (index *)malloc(sizeof(index));
		ptrTail->nd = ptr;
	}
	ptrTail->next = NULL;
	
	fclose(fptr);

	for (p = listPtrHead.next; p; p = p->next) 
		insert(0,p->nd,0);
}

void reorder()
{
	char  choice;
	index *p;
	
	printf("\n\nHa)  b)IDjp̧ǫإߦCHJab => ");
	choice = getche();
	head->next = NULL;
	if (choice == 'a' || choice == 'A') 
		for (p = listPtrHead.next; p; p = p->next) insert(0,p->nd,0);
	else if (choice == 'b' || choice == 'B')
		for (p = listPtrHead.next; p; p = p->next) insert(0,p->nd,1);
	else 
		printf("\nOops!Jڤ{oﶵAsorryAпJab\n\n");	
}
